unit AddInObj;
interface
uses
  //Variants,

  Dialogs,

  ComServ, ComObj, ActiveX, AddInLib, PropPage,
  SysUtils, Windows, Messages, Classes, Graphics, Controls, StdCtrls,
  ExtCtrls, {Forms,} StdVcl, AxCtrls;


Const
  ExtensionName_Comp      = 'COM_InProc_d5_vk';
  //ExtensionName_Comp_Vers = '_01';
  ExtensionName_Comp_Vers = '';
  dllName_Comp            = ExtensionName_Comp+ExtensionName_Comp_Vers;



Const
  // "" - OutProc COM-server
  OutProc_COM_Starter_Name = 'COM_InProc_d5_Starter.Tools';


Const {Props}
  IsEnabled_str = 'IsEnabled,';
  IsEnabled_num = 0;
  IsConnected_str = 'IsConnected,';
  IsConnected_num = 1;


Const {Methods}
  Enable_str    = 'Enable,';
  Enable_num    = 0;
  Disable_str   = 'Disable,';
  Disable_num   = 1;
  ShowInStatusLine_str = 'ShowInStatusLine,';
  ShowInStatusLine_num = 2;
  Connect_str    = 'Connect,';
  Connect_num    = 3;
  Disconnect_str = 'Disconnect,';
  Disconnect_num = 4;


//==========================================================================
//    
resourcestring
  str_IsEnabled = IsEnabled_str;

  str_Enable    = Enable_str;                  //
  str_Disable   = Disable_str;                 //
  str_ShowInStatusLine = ShowInStatusLine_str; //(,)

  str_IsConnected  = IsConnected_str;     //
  str_Connect      = Connect_str;         //()
  str_Disconnect   = Disconnect_str;      //()

  
//==========================================================================


const
  CLSID_AddInObject : TGUID = '{2F1ACD26-7A71-49B4-BB87-77FFFC5407BD}';

type

  TProperties = (
                 prop_IsEnabled,     //
                 prop_IsConnected,   //   - Az_1C
                 LastProp            // () 
                 );

  TMethods = (
              meth_Enable,           //
              meth_Disable,          //
              meth_ShowInStatusLine, //(,)
              meth_Connect,          //()      - Az_1C
              meth_Disconnect,       //()    - Az_1C
              LastMethod             // () 
              );

  TAddInObject = class (TComObject, IDispatch, IInitDone, ISpecifyPropertyPages, ILanguageExtender,IPropertyLink)

      //================================================
        { Attributes }
      boolIsEnabled : Integer; //    IsEnabled

      InProc_COM : variant;         //InProc-server
      OutProc_COM_Starter : variant; // (OutProc-server   InProc-server    )
      //================================================


      //================================================
        { Interfaces }
      pConnect    : Variant;
      pErrorLog   : IErrorLog;
      pEvent      : IAsyncEvent;
      pProfile    : IPropertyProfile;
      pStatusLine : IStatusLine;
      //================================================


      function LoadProperties: Boolean;
      procedure SaveProperties;
        { This function is useful in ILanguageExtender implementation }
      function TermString(strTerm: string; iAlias: Integer): string;
        {These two methods is convenient way to access function
         parameters from SAFEARRAY vector of variants }
      function GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
      procedure PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);

        { Interface implementation }
        { IInitDone implementation }
      function Init(pConnection: IDispatch): HResult; stdcall;
      function Done: HResult; stdcall;
      function GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
        { ISpecifyPropertyPages implementation }
      function GetPages(out Pages: TCAGUID) : HResult; stdcall;
        { ILanguageExtender implementation }
      function RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
      function GetNProps(var plProps: Integer): HResult; stdcall;
      function FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
      function GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
      function GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
      function SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
      function IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
      function IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
      function GetNMethods(var plMethods: Integer): HResult; stdcall;
      function FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
      function GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
      function GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
      function GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
      function HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
      function CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
      function CallAsFunc(lMethodNum: Integer; var pvarRetValue: OleVariant; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
        { IPropertyLink implementation }
      function get_Enabled(var IsEnabled : Integer): HResult; stdcall;
      function put_Enabled(IsEnabled : Integer): HResult; stdcall;


        { IDispatch }
      function GetIDsOfNames(const IID: TGUID; Names: Pointer;
        NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
      function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
      function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
      function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
        Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;
  end;

implementation



//*********************************************************************
//*********************************************************************
//*********************************************************************

function TAddInObject.Init(pConnection: IDispatch): HResult; stdcall;
Var
  iRes : Integer;
begin
  pConnect := pConnection;

  pErrorLog := nil;
  pConnection.QueryInterface(IID_IErrorLog,pErrorLog);

  pEvent := nil;
  pConnection.QueryInterface(IID_IAsyncEvent,pEvent);

  pProfile := nil;
  iRes := pConnection.QueryInterface(IID_IPropertyProfile,pProfile);
  if (iRes = S_OK) then begin
     pProfile.RegisterProfileAs(ExtensionName_Comp+' Profile Name');
     if (LoadProperties() <> True) then begin
        Init := E_FAIL;
        Exit;
     end;
  end;

  pStatusLine := nil;
  pConnection.QueryInterface(IID_IStatusLine,pStatusLine);

  InProc_COM :=UnAssigned;
  OutProc_COM_Starter :=UnAssigned;


  Init := S_OK;
end;

function TAddInObject.Done: HResult; stdcall;
begin
  SaveProperties();

  pConnect := Unassigned;
  pErrorLog := nil;
  pEvent := nil;
  pProfile := nil;
  pStatusLine := nil;

  //Timer.Destroy();

  if not VarIsEmpty(InProc_COM) then begin
     InProc_COM:=UnAssigned;
  end;
  if not VarIsEmpty(OutProc_COM_Starter) then begin
     OutProc_COM_Starter:=UnAssigned;
  end;

  Done := S_OK;
end;

function TAddInObject.GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
Var
  varInfo : OleVariant;
begin
  varInfo := '2000'; //  2.0
  PutNParam(pInfo,0,varInfo);
  GetInfo := S_OK;
end;

{ ILanguageExtender interface }
function TAddInObject.RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
begin
  bstrExtensionName := ExtensionName_Comp;
  RegisterExtensionAs := S_OK;
end;


function TAddInObject.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.GetTypeInfo(Index, LocaleID: Integer;
  out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

//*********************************************************************
//*********************************************************************
//*********************************************************************




//*********************************************************************
//*********************************************************************

{ ISpecifyPropertyPages interface }
function TAddInObject.GetPages(out Pages: TCAGUID) : HResult; stdcall;
begin
  Pages.cElems := 1;
  Pages.pElems := CoTaskMemAlloc(SizeOf(TGUID));
  (Pages.pElems)[0] := Class_AddInPropPage;
  GetPages := S_OK;
end;

function TAddInObject.LoadProperties: Boolean;
Var
  iRes : Integer;
  varRead : OleVariant;
begin
  VarClear(varRead);
  { SImply cast OleVariant to Integer (VT_I4) }
  varRead := 0;
  iRes := pProfile. Read('Enabled:0',varRead,nil);
  if (iRes <> S_OK) then begin
     LoadProperties := False;
     Exit;
  end;
  boolIsEnabled := varRead;
  LoadProperties := True;
end;

procedure TAddInObject.SaveProperties;
Var
  varSave : OleVariant;
begin
  varSave := boolIsEnabled;
  pProfile. Write('Enabled:0',varSave);
end;
//*********************************************************************
//*********************************************************************



function TAddInObject.TermString(strTerm: string; iAlias: Integer): string;
//        iAlias (0-  1-)
Var
  iSemicolon: Integer;
begin
  iSemicolon := Pos(',',strTerm);
  if (iAlias = 0) then
     if (iSemicolon = 0) then
        TermString := strTerm
     else
        TermString := Copy(strTerm,1,iSemicolon-1)
  else { iAlias = 1}
     if (iSemicolon = 0) then
        TermString := ''
     else
        TermString := Copy(strTerm,iSemicolon+1,Length(strTerm) - iSemicolon);
end;

function TAddInObject.GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
//   pArray       lIndex
Var
  varGet : OleVariant;
begin
  SafeArrayGetElement(pArray,lIndex,varGet);
  GetNParam := varGet;
end;

procedure TAddInObject.PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);
begin
  SafeArrayPutElement(pArray,lIndex,varPut);
end;



//*************************************************************************
//*************************************************************************
//*************************************************************************
//       

function TAddInObject.GetNProps(var plProps: Integer): HResult; stdcall;
//   (  )
begin
  plProps := Integer(LastProp);
  GetNProps := S_OK;
end;

function TAddInObject.FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
//        (, ). 
begin
  plPropNum := -1;

  //========================================
  //
  if (bstrPropName = TermString(str_IsEnabled,0)) then plPropNum := IsEnabled_num;
  if (bstrPropName = TermString(str_IsEnabled,1)) then plPropNum := IsEnabled_num;
  //========================================

  //========================================
  //
  if (bstrPropName = TermString(str_IsConnected,0)) then plPropNum := IsConnected_num;
  if (bstrPropName = TermString(str_IsConnected,1)) then plPropNum := IsConnected_num;
  //========================================


  if (plPropNum = -1) then begin
      FindProp := S_FALSE;
      Exit;
  end;

  FindProp := S_OK;
end;


function TAddInObject.GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
//   
begin
  pbstrPropName := '';
  case TProperties(lPropNum) of
     prop_IsEnabled:   //
       begin
         pbstrPropName := TermString(str_IsEnabled,lPropAlias);
       end;
     prop_IsConnected:  //
       begin
         pbstrPropName := TermString(str_IsConnected,lPropAlias);
       end;
     else
       GetPropName := S_FALSE;
       Exit;
  end;

  GetPropName := S_OK;
end;


function TAddInObject.GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
//   (-  )
begin

  VarClear(pvarPropVal);

  case TProperties(lPropNum) of
     prop_IsEnabled: //
       begin
         pvarPropVal := boolIsEnabled;
       end;
     prop_IsConnected: //
       begin
         if not VarIsEmpty(InProc_COM) then begin
            pvarPropVal := True;
         end
         else begin
            pvarPropVal := False;
         end;

       end;
     else
       GetPropVal := S_FALSE;
       Exit;
  end;

  GetPropVal := S_OK;
end;

function TAddInObject.SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
//    (-  )
begin

  case TProperties(lPropNum) of
     prop_IsEnabled:  //
       begin
         boolIsEnabled := varPropVal;
       end;
     prop_IsConnected:     //
       begin
         //   
       end;
     else
       SetPropVal := S_FALSE;
       Exit;
  end;

  SetPropVal := S_OK;

end;

function TAddInObject.IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
//    : " "
begin

  case TProperties(lPropNum) of
     prop_IsEnabled:    //
       begin
         pboolPropRead := 1;
       end;
     prop_IsConnected:  //
       begin
         pboolPropRead := 1;
       end;
     else
       IsPropReadable := S_FALSE;
       Exit;
  end;

  IsPropReadable := S_OK;

end;

function TAddInObject.IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
//    : " "
begin
  case TProperties(lPropNum) of
     prop_IsEnabled:    //
       begin
         pboolPropWrite := 1;
       end;
     prop_IsConnected:  //
       begin
         pboolPropWrite := 0;  // 
       end;
     else
       IsPropWritable := S_FALSE;
       Exit;
  end;

  IsPropWritable := S_OK;

end;



// #############################################################################
// 

function TAddInObject.get_Enabled(var IsEnabled : Integer): HResult; stdcall;
// ""   IsEnabled
begin
  IsEnabled := boolIsEnabled;
  get_Enabled := S_OK;
end;


function TAddInObject.put_Enabled(IsEnabled : Integer): HResult; stdcall;
// ""   IsEnabled
begin
  boolIsEnabled := IsEnabled;

  //-----------------------------------------------
  // .   1
  if (boolIsEnabled = 0) then begin
     //pEvent.ExternalEvent('','','0');
     pEvent.ExternalEvent(ExtensionName_Comp,'State','0');
  end
  else begin
     //pEvent.ExternalEvent('','','1');
     pEvent.ExternalEvent(ExtensionName_Comp,'State','1');
  end;
  //-----------------------------------------------

  put_Enabled := S_OK;
end;

// #############################################################################


//*************************************************************************
//*************************************************************************
//*************************************************************************





//*************************************************************************
//*************************************************************************
//*************************************************************************
//     

function TAddInObject.GetNMethods(var plMethods: Integer): HResult; stdcall;
//   (  )
begin
  plMethods := Integer(LastMethod);
  GetNMethods := S_OK;
end;

function TAddInObject.FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
//        (, ).
begin
  plMethodNum := -1;

  //========================================
  //()
  if (bstrMethodName = TermString(str_Enable,0))     then plMethodNum := Enable_num;
  if (bstrMethodName = TermString(str_Enable,1))     then plMethodNum := Enable_num;
  //========================================

  //========================================
  //()
  if (bstrMethodName = TermString(str_Disable,0))    then plMethodNum := Disable_num;
  if (bstrMethodName = TermString(str_Disable,1))    then plMethodNum := Disable_num;
  //========================================


  //========================================
  //(,)
  if (bstrMethodName = TermString(str_ShowInStatusLine,0)) then plMethodNum := ShowInStatusLine_num;
  if (bstrMethodName = TermString(str_ShowInStatusLine,1)) then plMethodNum := ShowInStatusLine_num;
  //========================================


  //========================================
  //()
  if (bstrMethodName = TermString(str_Connect,0))    then plMethodNum := Connect_num;
  if (bstrMethodName = TermString(str_Connect,1))    then plMethodNum := Connect_num;
  //========================================

  //========================================
  //()
  if (bstrMethodName = TermString(str_Disconnect,0)) then plMethodNum := Disconnect_num;
  if (bstrMethodName = TermString(str_Disconnect,1)) then plMethodNum := Disconnect_num;
  //========================================


  if (plMethodNum = -1) then begin
     FindMethod := S_FALSE;
     Exit;
  end;

  FindMethod := S_OK;

end;

function TAddInObject.GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
//  
begin

  pbstrMethodName := '';

  case TMethods(lMethodNum) of
     meth_Enable:  //
       begin
         pbstrMethodName := TermString(str_Enable,lMethodAlias);
       end;
     meth_Disable: //
       begin
         pbstrMethodName := TermString(str_Disable,lMethodAlias);
       end;
     meth_ShowInStatusLine: //(,)
       begin
         pbstrMethodName := TermString(str_ShowInStatusLine,lMethodAlias);
       end;
     meth_Connect:   //()
       begin
         pbstrMethodName := TermString(str_Connect,lMethodAlias);
       end;
     meth_Disconnect:  //()
       begin
         pbstrMethodName := TermString(str_Disconnect,lMethodAlias);
       end;
     else
       begin
         GetMethodName := S_FALSE;
         Exit;
       end;
  end;

  GetMethodName := S_OK;

end;


function TAddInObject.GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
//     
begin

  plParams := 0;

  case TMethods(lMethodNum) of
     meth_Enable:     //
       begin
         plParams := 0;
       end;
     meth_Disable:    //
       begin
         plParams := 0;
       end;
     meth_ShowInStatusLine:  //(,)
       begin
         plParams := 2;
       end;
     meth_Connect:    //()
       begin
         plParams := 0;
       end;
     meth_Disconnect:  //()
       begin
         plParams := 0;
       end;

     else
       begin
          GetNParams := S_FALSE;
          Exit;
       end;
  end;

  GetNParams := S_OK;

end;

function TAddInObject.GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
//    -    
begin
  { Ther is no default value for any parameter }
  VarClear(pvarParamDefValue);
  GetParamDefValue := S_OK;
end;

function TAddInObject.HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
//     (..,    )
begin
  pboolRetValue := 0; //FALSE

  case TMethods(lMethodNum) of
    meth_Connect:  //()
      begin
        pboolRetValue := -1;  //TRUE
      end;

    else
      begin
        HasRetVal := S_FALSE;
        Exit;
      end;
  end;

  HasRetVal := S_OK;
end;



// #############################################################################
// 

function TAddInObject.CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
//,   1C,  
Var
  pForm : Variant;

begin
  case TMethods(lMethodNum) of
     meth_Enable:  //()
       begin
         boolIsEnabled := 1;
       end;
     meth_Disable: //()
       begin
         boolIsEnabled := 0;
       end;

     meth_ShowInStatusLine: //(,)
       begin
         pStatusLine.SetStatusLine(GetNParam(paParams,0));
         //Sleep(5000);
         // 2- 
         if GetNParam(paParams,1)*1>0 then begin
            //  2-  >0
            //    - 
            Sleep(GetNParam(paParams,1)*1000);
         end;
       end;

     meth_Disconnect:  //()
       begin
         if not VarIsEmpty(InProc_COM) then begin
            InProc_COM:=UnAssigned;
         end;
         if not VarIsEmpty(OutProc_COM_Starter) then begin
            OutProc_COM_Starter:=UnAssigned;
         end;
       end;

     else
       begin
          CallAsProc := S_FALSE;
          Exit;
       end;
  end;

  CallAsProc := S_OK;
end;


function TAddInObject.CallAsFunc(lMethodNum: Integer;
                                 var pvarRetValue: OleVariant;
                                 var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
//,   1C,  

begin

  case TMethods(lMethodNum) of

     meth_Connect:  //: ()
       begin
         pvarRetValue:=UnAssigned;  //  -   InProc COM-server
         if not VarIsEmpty(InProc_COM) then begin
            InProc_COM:=UnAssigned;
         end;

         if VarIsEmpty(OutProc_COM_Starter) then begin
            // ""    - 

            OutProc_COM_Starter:=CreateOleObject(OutProc_COM_Starter_Name);

         end;

         InProc_COM:=OutProc_COM_Starter.CreateOleObject_MyCOM;  //   InProc COM-server

         if not VarIsEmpty(InProc_COM) then begin

            pvarRetValue:=InProc_COM;  //  -   InProc COM-server

         end
         else begin
            ShowMessage('Error!  InProc COM-server - not found or not access');
         end;

       end;

    else
      begin
        CallAsFunc := S_FALSE;
        Exit;
      end;
  end;

  CallAsFunc := S_OK;

end;

// #############################################################################


//*************************************************************************
//*************************************************************************
//*************************************************************************










//*************************************************************************

initialization

  ComServer.SetServerName('AddIn');
  TComObjectFactory.Create(ComServer,TAddInObject,CLSID_AddInObject,
                        dllName_Comp,'V7 AddIn 2.0',ciMultiInstance);

end.



